
(*
 * varstr.inc - Library to manipulate variable-allocation strings.
 *
 * (C) 1987 Samuel H. Smith, 18-Oct-87 (rev. 18-Oct-87)
 *
 *)

procedure releasestr( var str:  varstring);
   (* release the memory used by a varstring variable.  variable MUST
      be pre-allocated or the program may crash!!! *)
var
   olen: integer;
begin
   if str <> nil then
   begin
      olen := ord(str^[length(str^)+1]);
      if length(str^) <> olen then
      begin
         writeln(^G'release: [',str^,'] ',olen,^G^G^G);  
         olen := olen div 0; {signal runtime error}
      end;
      
      freemem(str,length(str^)+2);
      str := nil;
   end;
end;


procedure savestr( var tostr: varstring;
                   from:      longstring);
   (* save a regular string in a varstring; new allocation of varstring *)
begin
   releasestr(tostr);
   getmem(tostr, length(from)+2);
   tostr^ := from;
   tostr^[length(from)+1] := chr(length(from));
end;


